var arrObjects = [];
var gEntity = "";
var editor;

function setEditPortlets() {
	$("#perspective .portlet").trigger("edit");
	$("#perspective").bind("click", function(event, p1, p2) {
		$("#perspective .portlet").removeClass("portlet-selected");
		$("#portlet_properties").hide();
	});
}

function EditerPerspective() {
	$("#side").hide();
	$("#btnEdit").hide();
	$("#editmodebar").show();
	$("#normalmodebar").hide();
	$("#tools").show();
	$("#perspective").addClass("perspective-edit");
	$(".perspective-editable").attr("contenteditable", "true");
	$(".perspective-editable").addClass("edit");
	setEditPortlets();

}

function AnnulerPerspective() {
	$("#perspective .portlet").trigger("undo");
	evaluerPerspective(gEntity);
}

function createPortlet() {
	id = new Date().getTime();
	$("#perspective").append('<div id="' + id + '"></div>');
	return $("#" + id);
}

function ajouterPortlet(type,options) {
	portlet = createPortlet();
	switch (type) {
		case "ui.list":portlet.list();break;
		case "ui.action":portlet.action();break;
		case "ui.label":portlet.label(options);break;
		case "ui.errors":portlet.errors();break;
		case "ui.timeline":portlet.timeline();break;
		case "ui.texte":portlet.texte();break;
		case "ui.separateur":portlet.label({style:"border-bottom:2px solid black",libelle:"",position:{height:5}});break;
	}

	//setEditPortlets();
	return portlet;
}

function unsetEditPortlets() {
	$("#perspective .portlet").trigger("canceledit");

}

function displayPerspective(jsondata) {
	
	$("#perspective").empty();
	//UIBlock("#perspective");
	
	//$("#perspective").css("opacity","0");
	
	//alert("start")
	jsondata = jsondata.replace(/\"\"{/g, "'\"{");
	jsondata = jsondata.replace(/}\"\"/g, "}\"'");
	portlets = $.parseJSON(jsondata);
	//arr=[]
	$.each(portlets, function(i, v) {
		portlet=ajouterPortlet(v.type);
		portlet.trigger("loadfirst", v);
	});
	//alert("stop");
	
}

var mNbEvaluation=0;
var mArrEvaluation=new Array();
function evaluerPerspective(entity) {
	gEntity = entity;
	mNbEvaluation=0;
	mArrEvaluation=new Array();
	
	/*$("#perspective .portlet").each(function (i) {
		$(this).trigger("evaluer", entity);
	});	*/
	
	$("#perspective .portlet").trigger("evaluer", entity);
	StartEvaluation(entity);
	
	$("#side_entity_composantes").hide();

	removeEditableClass();
	

}

function removeEditableClass() {
	$("#side").show();
	$("#btnEdit").show();
	$("#editmodebar").hide();
	$("#normalmodebar").show();
	$("#tools").hide();

	$(".perspective-editable").attr("contenteditable", "false");
	$(".perspective-editable").removeClass("edit");

	$("#perspective").removeClass("perspective-edit");

	unsetEditPortlets();
}


function ShowProperties(portlet,json) {

	var container = document.getElementById("jsoneditor");
	editor = new JSONEditor(container);
	editor.set(json);
	$(".jsoneditor-menu").hide();
	$(".jsoneditor-dragarea").hide();
	$("#portlet_properties").show();
	$(".jsoneditor-value").addClass("composantes-target");
	$("#keyevent").focus();
	current_portlet=portlet;
	adjustHeight("#composantes-content");
	
}

function ApplyProperties() {
	var json = editor.get();
	$("#" + json.id).trigger("apply", json);

	setEditPortlets();
}

function FrontObject()
{
	$(".portlet-selected").each(function (i) {
		$(this).css("z-index","1000");
	});	
}

function BackObject()
{
	$(".portlet-selected").each(function (i) {
		$(this).css("z-index","0");
	});	
}

function DeleteObject()
{
	$(".portlet-selected").each(function (i) {
		$(this).addClass("portlet-deleted");
	});
	
	$(".portlet").first().trigger("click");
}

function CopyObject()
{
	val= JSON.stringify(current_portlet.getJsonTree())
	clipboard_set(val);
}

function PasteObject()
{
	var json=JSON.parse(clipboard_get());
	var portlet=ajouterPortlet(json.type,{});
	json.id=portlet[0].id;
	json.position.top=json.position.top+10;
	json.position.left=json.position.left+10;
	portlet.trigger("apply", json);
	portlet.trigger("click", json);
	
}

function DupObject()
{
	CopyObject();
	PasteObject();	
}

function ImporterPerspective()
{
	alert("Non implémenté")
}

function ExportPerspective(id)
{
	/*$.ajax({
            url: '/perspective/'+id+'/export'  ,
            data: {},
            type: 'GET',
            success: function( response ) {}
           
    });*/
    window.open('/perspective/'+id+'/export')	;
}


function refreshPerspective(id) {
	$("#listperspectives").jqGrid().trigger("reloadGrid");

}

function displayContextuelle(uid,id)
{
	if (id==-1) return;
	adjustHeight("#perspective");

	$.ajax({
            url: '/perspective/'+id  ,
            data: {},
            type: 'GET',
            success: function( response )
            {
            	if (response.contexte!=1) // 1=mode contextuel
            	{
            		//window.location.href="/entity/"+uid+"/default?pid="+id
            		currentPerspective=id
            		ShowEntity(uid)
            	} else
            	{
            		$("#perspective").animate({opacity:0},{duration:'fast',complete: function()
					{
				
					} });
            		
					$("#objets").hide();
					$("#marker_contexte").show();
					ajusterLaLongueurDeLaCarte(true);  
	
					currentUid=uid;
					currentPerspectiveContextuelId=id;
					displayPerspective(response.data);
				    evaluerPerspective(uid);  
				    h=$("#footer").position().top- $("#perspective").position().top
				    $("#perspective").css("height",h-5)
				    //UIUnBlock("#perspective");
				}
			                
            }
    });
}

