(function( $ ) {
  $.widget( "ui.portlet", {

    editMode: false,
    arrEvaluer: [],
    savedTree: {},

    // These options will be used as defaults
    options: { 
      clear: null,
      titre : {afficher:true,texte:"Titre",style:"border: 1px solid white"},
      style:"border-radius:5px; border:1px solid black;background: #f1f6fe; padding:2px"
    },

    // Set up the widget
    _create: function() {
    	var self = this;
    	var el=self.element;
    	el.addClass("portlet");
    	el.addClass("composantes-target");

        var c='<table style="width:100%; height:100%;"><tr>'
        
        +'<td class="portlet-content" style="vertical-align: top;">'
        +'<div class="ui-widget-header portlet-header" style="display: none;">Titre</div>'
        +'</td>'
        
        +'<td class="portlet-tool1 ui-state-active" style="display: none; vertical-align: top;">'
        +'<button class="deletebtn toolbtn">Supprimer</button>'
        +'</td>'
        
        
        
        
        
        +'</tr></table>' ;

        el.append(c);
    	//el.append('<div class="ui-widget-header portlet-header" style="display: none;">Titre</div>');

		el.bind("getid", function(event,p1,p2){return self.id();});
        el.bind("drop", function(event,p1,p2){self.drop(p1);});
        el.bind("edit", function(event,p1,p2){self._edit();});
        el.bind("canceledit", function(event,p1,p2){self._canceledit();});
        el.bind("apply", function(event,p1,p2){self._apply(p1);});
        el.bind("save", function(event,p1,p2){self._save();});
        el.bind("actionsave", function(event,p1,p2){self._actionsave();});
        
        //$("body").bind("keydown", function(event,p1,p2){self.keypress(event);});

		el.bind("moveend", function(event,p1,p2){
			json=self._save();
			this.jsonTree.position=json.position;
		});

        el.bind("load", function(event,p1,p2){self._load(p1);});
        el.bind("loadfirst", function(event,p,p2)
        {
            ppos=$("#perspective").position();
        	p.position.left+=ppos.left;//+15 ;
        	//p.position.top-=5;
        	//p.position.top=ppos.top  ; 
        	
            self._load(p);
            self.savedTree=p;
            self.jsonTree=p;
           
        });
        el.bind("undo", function(event,p1,p2){self._undo();});
        el.bind("saveposition", function(event,p1,p2){self.savePosition();});
        el.bind("evaluer", function(event,p1,p2){self._evaluer(p1);});
        el.bind("click", function(event,p1,p2){self.click(event);event.stopImmediatePropagation();});

        el.find(".deletebtn").button({ "text":false,  "icons": {primary:'ui-icon-trash'} }).click(
            function(){
               self.element.addClass("portlet-deleted");
            }
        );
        
        ppos=$("#perspective").position();
        el.css({left:ppos.left,top:ppos.top/*+200*/});

    },
    
    savePosition: function()
    {
    	json=this._save();
		this.jsonTree.position=json.position;
    },
    
    keypress: function(e)
    {
    	var code = (e.keyCode ? e.keyCode : e.which);
    	alert(code);	
    },
    
    _apply: function(json)
    {
    	/*ppos=$("#perspective").position();
        json.position.left+=ppos.left ;
        json.position.top+=ppos.top ; */
    	this._load(json);
    		
    },
    
    _saveObject : function()
    {
    	this.savedTree=this._save();
    	this.jsonTree=this.savedTree;
        this._load(this.savedTree);
    },

    click : function(event)
    {
      if (!this.editMode) return false;
      if (event && !event.ctrlKey) {
      	$( "#perspective .portlet" ).removeClass("portlet-selected");
      }
      this.element.addClass("portlet-selected");
      this.element.removeClass("portlet-edit");
      this._showProperties();

    } ,

    _showProperties: function()
    {
        arrObjects=[];
        ShowProperties(this,this._save());
    },
    
    isInEditMode :function()
    {
    	return this.editMode;	
    },
    
    _OnResized : function()
    {
    	
    },
    
    _OnMoved : function()
    {
    	
    },
    
    id: function()
    {
    	return this.element[0].id;
    },
    
    
    getJsonTree: function()
    {
    	return this.jsonTree;
    },

    _edit: function() {
    	//this.jsonTree.position.top+=5;
    	var self=this
        this._load(this.jsonTree);
        //this.jsonTree.position.top-=5;
    	this.element.resizable({stop: function(event, ui) { 
    										    json=self._save();
												self.jsonTree.position=json.position;
												self._OnResized();	
    										 }})
    			     .draggable({ containment: "#perspective", 
    										 scroll: true,cursor: "move",
    										 stop: function(event, ui) { 
    										 	json=self._save();
												self.jsonTree.position=json.position;
												self._OnMoved();	
    										 } });
    	this.element.addClass("portlet-edit");
        $(".editbtn").show();
        $(".portlet-tool").show();
        this.editMode=true;
    },
    
    _canceledit : function()
    {
        this.element.draggable("destroy").resizable("destroy");
		this.element.removeClass("portlet-edit") ;
        $( "#perspective .portlet" ).removeClass("portlet-selected");
        $("#portlet_properties").hide();
        $(".editbtn").hide();
        $(".portlet-tool").hide();
        this.editMode=false;
    },
 
    // Use the _setOption method to respond to changes to options
    _setOption: function( key, value ) {
      switch( key ) {
        case "clear":
          // handle changes to clear option
          break;
      }
      //$.ui.portlet.prototype._create.call(this);
      //this._super( "_setOption", key, value );
    },

    drop: function(data) {alert("NO");},

    _evaluer : function ()
    {
    	 
		 return (typeof this.jsonTree != 'undefined' );
    },


    _undo: function()
    {
        this._load(this.savedTree) ;
        this.element.removeClass("portlet-deleted");
        
        /*ppos=$("#perspective").position();
        this.jsonTree.left-=ppos.left ;
        this.jsonTree.top-=ppos.top ; */
        
    } ,

    _save: function()
    {
        var el=this.element;

        if (el.hasClass("portlet-deleted")) return null;

        p=el.offset() ;
        
        /*ppos=$("#perspective").position();
        p.left-=ppos.left ;
        p.top-=ppos.top ; */

        ps={left:p.left, top: p.top,width:el.width(),height:el.height()};
        sav={id:el.context.id,position:ps,zindex:el.css("z-index"),
                              style:this.options.style,
                              titre:this.options.titre};
        //this.jsonTree=sav;
        //this.savedTree=sav;
        return sav;
    },

    _actionsave: function()
    {
        json=this._save();
        this.savedTree=json;
        arrObjects.push(json);
  
    },


    _load: function(p)
    {
    	
    	
        var self = this;
        self.arrEvaluer=[];

        var e=this.element;
        
        this.jsonTree=p;
		//p.position.top+=5;

        e.offset(p.position);
		e.css({width:p.position.width,height:p.position.height})
		if (p.zindex)
		{
			e.css("z-index",p.zindex);
		}
		
        header=this.element.find(".portlet-header");
        header.css("display",p.titre.afficher?"block":"none");
        header.html(p.titre.texte) ;

        header.css(toCss(p.titre.style));
        this.options.titre= p.titre;

        e.css(toCss(p.style));
        this.options.style= p.style;

        
    },
 
    // Use the destroy method to clean up any modifications your widget has made to the DOM
    _destroy: function() {
     
    }
  });
}( jQuery ) );
