// ACTION =============================================
(function( $ ) {
  $.widget( "ui.action",$.ui.portlet,  {
  	
  	options: { 
      libelle: "Action",
      commande:"",
      style:"border:none;background: none; padding:2px"
    },
  	
    // Set up the widget
    _create: function() {
    	var self = this;
		this.options.titre.afficher=false;
		
		var el=this.element;
		el.css({width:100,height:40});

        $.ui.portlet.prototype._create.call(this);

    	var el=self.element.find(".portlet-content");
        el.append("<button class='portlet-button'>"+this.options.libelle);
        
        this.element.find(".portlet-button").button().click(
        	function() {
        		self._commande();
        	}
        );
        
        this._saveObject();
	
    },
    
    _commande: function()
    {
    	if (this.isInEditMode()) return;
    	url=this.options.valeur;
    	
    	var str = url.match(/\$\(.*\)?/g);
    	if (str!=null)
    	{
	    	for (i=0;i<str.length;i++)
	    	{
	    		s=str[i].replace("$(","$('#")
	    		s=s.replace(")","').val()");
	    		url=url.replaceAll(str[i],eval(s));
	    	}
	   	}
    	
    	if (!url.startsWith("http"))
    	{
    		cmd="sentinelle://"+url+"";
    		cmd=cmd.replaceAll("&amp;","&");
    		$("#perspectiveaction").attr("src",cmd);
    	} else
    	{
    		window.open(url);
    	}
    	
    },

    _evaluer : function (entity)
    {
        if (!$.ui.portlet.prototype._evaluer.call(this,entity)) return;

        formats=[];arrEvaluer=[];
        var self=this;
        
        arrEvaluer.push({obj:self.options});
        formats.push(self.options.commande);

        evaluation(this.element,entity,arrEvaluer,formats,function(obj,valeur)
		{
		    	obj.valeur=valeur;	
		}) 
    },

    _save: function()
    {
        json=$.ui.portlet.prototype._save.call(this);
        if (json==null) return;
        json.type="ui.action";
        btn=this.element.find(".portlet-button");
        json.libelle=$("span", btn).text();
        json.commande=this.options.commande;
        return json;
    },

    _load: function(json)
    {
        var self=this;
        $.ui.portlet.prototype._load.call(this,json);
        btn=this.element.find(".portlet-button");
        $("span", btn).text(json.libelle);
        this.options.libelle=json.libelle;
        this.options.commande=json.commande;
        this.jsonTree=json;
    }

});
}( jQuery ) );
// ==============================================================

