
(function( $ ) {
  $.widget( "ui.label",$.ui.portlet,  {
  	
  	options: { 
      libelle: "Label",
      style:"border:none;background: none; padding:2px"
    },
  	
    // Set up the widget
    _create: function() {
    	var self = this;
		this.options.titre.afficher=false;
		
		var el=this.element;
		el.css({width:200,height:40});

        $.ui.portlet.prototype._create.call(this);
        var el=self.element.find(".portlet-content");
        el.append("<div class='portlet-label'>"+this.options.libelle);
        
        this._saveObject();
	
    },
    
    _evaluer : function (entity)
    {
        if (!$.ui.portlet.prototype._evaluer.call(this,entity)) return;

        formats=[];arrEvaluer=[];
        var self=this;
        
        arrEvaluer.push({obj:self.options});
        formats.push(self.jsonTree.libelle);

        evaluation(this.element,entity,arrEvaluer,formats,function(obj,valeur)
		{
		    	elt=self.element.find(".portlet-label");
        		elt.html(valeur);
		}) 
    },
    
    _OnResized : function ()
    {
        $.ui.portlet.prototype._OnResized.call(this);
        this.resizeLabel()
    },
    
    resizeLabel: function()
    {
    	elt=this.element.find(".portlet-label");
        var w=this.element.width();var h=this.element.height();
        elt.css({"width":w,"height":h});
    },
    
    _edit: function()
    {
    	$.ui.portlet.prototype._edit.call(this);
    	$(this).val(this.jsonTree.libelle);
    },

    _save: function()
    {
        json=$.ui.portlet.prototype._save.call(this);
        if (json==null) return;
        json.type="ui.label";
        elt=this.element.find(".portlet-label");
        json.libelle=elt.text();
        return json;
    },

    _load: function(json)
    {
        var self=this;
        $.ui.portlet.prototype._load.call(this,json);
        elt=this.element.find(".portlet-label");
        elt.text(json.libelle);
        this.jsonTree=json;
        this.resizeLabel();
    }

});
}( jQuery ) );
// ==============================================================

