// TEXT =============================================
(function( $ ) {
  $.widget( "ui.texte",$.ui.portlet,  {
  	
  	options: { 
      identifiant: "id",
      libelle:  "valeur",
      style:"border:none;background: none; padding:2px"
    },
  	
    // Set up the widget
    _create: function() {
    	var self = this;
		this.options.titre.afficher=false;
		
		var el=this.element;
		el.css({width:100,height:40});

        $.ui.portlet.prototype._create.call(this);

    	var el=self.element.find(".portlet-content");
        el.append("<input class='portlet-text' type='text' value='"+this.options.libelle+"'>");
        
        this._saveObject();
	
    },
    
    _evaluer : function (entity)
    {
        if (!$.ui.portlet.prototype._evaluer.call(this,entity)) return;

        formats=[];arrEvaluer=[];
        var self=this;
        
        arrEvaluer.push({obj:self.options});
        formats.push(self.options.libelle);

        evaluation(this.element,entity,arrEvaluer,formats,function(obj,valeur)
		{
				input=self.element.find(".portlet-text");
        		input.val(valeur);
		}) 
    },

    _save: function()
    {
        json=$.ui.portlet.prototype._save.call(this);
        if (json==null) return;
        json.type="ui.texte";
        input=this.element.find(".portlet-text");
        json.libelle=input.val();
        json.identifiant=input[0].id;
        return json;
    },

    _load: function(json)
    {
        var self=this;
        $.ui.portlet.prototype._load.call(this,json);
        input=this.element.find(".portlet-text");
        input.val(json.libelle);
        input[0].id=json.identifiant;
        this.options.libelle=json.libelle;
        this.options.identifiant=json.identifiant;
        this.jsonTree=json;
    }

});
}( jQuery ) );
// ==============================================================

