# -*- coding: utf-8 -*-
class Group <  User

  MANAGER="@manager"
  ALL="@all"
  NOBODY="@nobody"
  ADMIN="@admin"
  GUEST="@guest"
  CAS_USER="@cas_user"
  GPS="@gps"
  #CONNECTED="@connected"



  has_and_belongs_to_many :users

  before_save do
    self.users=self.users.uniq
    true
  end

  before_create do
    #self.dynamic=false
    #true
    self.categorie=GROUP
    true
  end

  #def initialize(*params)
  #  super(*params)
  #  self.categorie=GROUP
    #self.dynamic=params[:dynamic]
  #end

  def self.dynamique(groupemane,user,source)
    
    return if groupemane==nil || groupemane.empty?
    
    group=Group.find_by_uid("@#{groupemane}")
    # Le groupe n'existe pas on le créé
    if group == nil
      logger.info(" => Création de @#{groupemane}")
      group=Group.create(:nom => "",
      :prenom => "#{groupemane} (#{source})",
      :uid => "@#{groupemane}", :dynamic => true )
    end

    return if ! group.dynamic  # Ce n'est pas un groupe dynamique, on n'y ajoute pas le user
    
    group.users << user if ! group.users.exists? user
    group.save
  end


  def admin?
    uid==Group::ADMIN
  end
  
  def all?
    uid==Group::ALL  
  end
  
  def nobody?
    uid==Group::NOBODY  
  end

  def self.cas_user
    Group.find_by_uid(CAS_USER)
  end
  
  def self.all
    Group.find_by_uid(ALL)
  end

  def self.nobody
    Group.find_by_uid(NOBODY)
  end
  
  def self.admin
    Group.find_by_uid(ADMIN)
  end

  def self.manager
    Group.find_by_uid(MANAGER)
  end
  
  def self.gps
    Group.find_by_uid(GPS)
  end

  def self.guest
    Group.find_by_uid(GUEST)
  end

  #def self.connected
  #  Group.find_by_uid(CONNECTED)
  #end
 
end