#!/bin/bash

# Initialisation de la base de données
# Attention : cette procédure va écraser les données existantes

SENTINELLE_HOME="/usr/share/sentinelle"
SENTINELLE_APP="$SENTINELLE_HOME/alizes"


sudo /etc/init.d/apache2 stop >/dev/null 2>&1
sudo service mysql restart >/dev/null 2>&1

find public -name "application*js*" -exec rm {} \;
rm -rf /tmp/zephir/* >/dev/null 2>&1

if [ ! -e data/.zephir ] ; then
	echo -n "Host Zephir: "; read ZEPHIR_HOST
	echo -n "Login Zephir: "; read ZEPHIR_LOGIN
	echo -n "Mot de passe: "; stty -echo; read  ZEPHIR_PWD ; stty echo

	echo "ZEPHIR.site±ZEPHIR.ip±ZEPHIR.user±ZEPHIR.password" > data/.zephir
	echo "RECTORAT±$ZEPHIR_HOST±$ZEPHIR_LOGIN±$ZEPHIR_PWD" >> data/.zephir
fi


# Roolback total, drop de la base + cration d'une base toute neuve
rake db:rollback && rake db:drop && rake db:create && rake db:migrate --trace
if [ $? -eq 0 ]; then
	rails r "load 'script/init.rb'"
	#rails r "load 'script/reunion.rb'"
fi

#rm -rf data/.zephir

sudo /etc/init.d/apache2 start >/dev/null 2>&1
