#!/bin/sh

# TODO: tempaltiser config/database.yml

# Script à lancer lors d'une mise a jour de l'appli

export RAILS_ENV=production

echo "° Vérifications de modules"
bundle install >/dev/null

sudo chown -R sentinelle.www-data /usr/share/sentinelle/alizes
sudo chmod -R 774 .

echo "° Arrêt du serveur apache"
sudo /etc/init.d/apache2 stop >/dev/null 2>&1
sudo service mysql restart >/dev/null 2>&1

echo "° Génération des ressources (peut être long)"
rm -rf public/*
rm -rf tmp/*
rm -rf log/*
bundle exec rake assets:precompile >/dev/null 2>&1

echo "° Migration des données"
rake db:migrate


echo "

development:
  adapter: mysql2
  pool: 100
  database: rails
  username: rails
  password: rails
  socket: /var/run/mysqld/mysqld.sock
  encoding: utf8

production:
  adapter: mysql2
  pool: 100
  database: rails
  username: rails
  password: rails
  socket: /var/run/mysqld/mysqld.sock
  encoding: utf8
" > config/database.yml



sudo chown -R sentinelle.www-data /usr/share/sentinelle/alizes
sudo chmod -R 774 /usr/share/sentinelle/alizes
sudo chown sentinelle /usr/share/sentinelle/alizes/config/environment.rb
sudo chown sentinelle /usr/share/sentinelle/alizes/config.ru
sudo chmod -R g+s  /usr/share/sentinelle/alizes/public
sudo chmod -R g+s  /usr/share/sentinelle/alizes/tmp

sudo /etc/init.d/apache2 start
