
(function( $ ) {
  $.widget( "ui.errors",$.ui.portlet,  {
  	
  	options: { 
  	  serveurs:'',
      colonnes: { serveur: true,
			      composante:true,
			      message:true,
			      format:true},
      style:"border:1px solid red;border-radius:5px;background: #FFEEEE; padding:2px;overflow-y:auto"
    },
  	
    // Set up the widget
    _create: function() {
    	var self = this;
		this.options.titre.afficher=false;
		
		var el=this.element;
		el.css({width:200,});

        $.ui.portlet.prototype._create.call(this);
        var el=self.element.find(".portlet-content");
        el.append("<div class='portlet-errors'>");
        
        this._saveObject();
	
    },
    
    _evaluer : function (entity)
    {
        if (!$.ui.portlet.prototype._evaluer.call(this,entity)) return;
        
        var self=this;
		$.ajax({
        url: '/entity/'+entity+'/errors'  ,
        datatype:"json",
        data: {},type: 'GET',success: function(data)
        {
        	elt=self.element.find(".portlet-errors");
        	msg="<table class='composantes' cellspacing='0'>"
        	for (i=0;i<data.length;i++)
	        {
	            item=data[i]
	            msg+="<tr>"
	            if (self.options.colonnes.serveur)
	            	msg+="<td class='serveur'>"+item.serveur_name+" ("+item.uid+")</td>"
	            	
	           	if (self.options.colonnes.composante)
	            	msg+="<td class='composante'>"+item.composante_name+"</td>"
	            	
	            if (self.options.colonnes.format)
	            	msg+="<td class='format'>"+item.format+"</td>"
	            	
	            if (self.options.colonnes.message)
	            	msg+="<td class='message'>"+item.message+"</td>"	
	            	
	            msg+="</tr>"
	        }
	        msg+="<table>"	
	        elt.html(msg)
	        self.element.animate({opacity:1,duration:'fast'});
        }
    	});
         
    },
    
    _edit: function()
    {
    	$.ui.portlet.prototype._edit.call(this);
    	//$(this).val(this.jsonTree.libelle);
    },

    _save: function()
    {
        json=$.ui.portlet.prototype._save.call(this);
        if (json==null) return;
        json.type="ui.errors";
        json.serveurs=this.options.serveurs;
        json.colonnes=this.options.colonnes;
       /* elt=this.element.find(".portlet-label");
        json.libelle=elt.text();*/
        return json;
    },

    _load: function(json)
    {
        var self=this;
        $.ui.portlet.prototype._load.call(this,json);
        /*elt=this.element.find(".portlet-label");
        elt.text(json.libelle);*/
        this.options.serveurs=json.serveurs;
        this.options.colonnes=json.colonnes;
        this.jsonTree=json;
    }

});
}( jQuery ) );
// ==============================================================

