
function InitAccueil()
{
   $('#filters_filtre').selectmenu({style: "dropdown",menuWidth:300});
   $("#filters_filtre-button").css("width",300);

   $("#btnFilterNo").button({ "text": false,  "icons": {primary:'ui-icon-cancel'} }).click(function()
   {
       disableFilter();
   })  ;

   $("#btnExtandVue").click(function()
   {
       reduce("#filters");reduce("#rapportsblock");
       extend("#vuesblock") ;
   })  ;

   $("#btnExtandFiltres").click(function()
   {
       reduce("#vuesblock");reduce("#rapportsblock");
       extend("#filters") ;
   })  ;

   $("#btnExtandRapports").click(function()
   {
       reduce("#vuesblock");reduce("#filters");
       extend("#rapportsblock") ;
   })  ;
   $("#btnExtandRapports").show();
   
   $("#cancelSearch").button({ "text": false,  "icons": {primary:'ui-icon ui-icon-circle-close'} } ).click(function()
	  {
		$("#searchEtab").val("");
		mapsCallback=function() {fitToAll();}
		DrawMap();
		$("#marker_contexte").hide();
		$("#objets").show();
		ajusterLaLongueurDeLaCarte(false);
		HideSearchCancel();
	});
	
	$('#filters_filtre').change(function() {
        id=$('#filters_filtre').val();
        
        if (id=="")
        {
        	disableFilter();
        	return;
        }

        mapsCallback=function() {fitToAll();}

        $.ajax({
        url: '/main/filter_activate'  ,
        data: {id: id,actif: true,type: "filtres",exclusif:true},type: 'GET',success: function(data)
        {
        	$( "#listfiltres" ).trigger("reloadGrid");
        }
    	});
    });
    
    $("#showComposantes").button({ "text": false,  "icons": {primary:'ui-icon-notice'} } ).click(function()
	{
		//window.location.href="entity/"+currentUid+"/composantes";
		currentAction="composantes";
		ShowEntity(currentUid)
		
	});
	
	$("#showJournal").button({ "text": false,  "icons": {primary:'ui-icon ui-icon-calendar'} } ).click(function()
	{
		//window.location.href="entity/"+currentUid+"/journal";
		currentAction="journal";
		ShowEntity(currentUid)
	});
	
	$("#showHistoriques").button({ "text": false,  "icons": {primary:'ui-icon ui-icon-script'} } ).click(function()
	{
		//window.location.href="entity/"+currentUid+"/historiques";
		currentAction="historiques";
		ShowEntity(currentUid)
	});

	$("#showobjets").button({ "text": false,  "icons": {primary:'ui-icon ui-icon-circle-close'} } ).click(function()
	{
		
		$("#marker_contexte").hide();
		$("#objets").show();
		ajusterLaLongueurDeLaCarte(false); 
		//$( "#listvues" ).trigger("reloadGrid");
		
	});
	
	$("#editPerspective").button().click(function()
    {
    	window.location.href="entity/"+currentUid+"/default?edit=true&pid="+currentPerspectiveContextuelId
    	
    });
    
}

function rechercherEtablissement()
{
	$.ajax({
		url:'/main/entities',format: "json",type: 'GET',
    	success: function (data)
    	{	
    		features=data.features;
    		searchEtab=$("#searchEtab").val();
			if (searchEtab!= undefined && searchEtab!="")
				re=new RegExp(".*"+searchEtab+".*", "i");
			count=0;var entity="";
        	for (var i = 0; i < features.length; i++) 
        	{
	            item = features[i];
	            // Critere de recherche
	            if (re!=null)
	            {
	            	if ( !  re.test(item.title) && ! re.test(item.description) )
	            	{
	            		continue
	            	}
	            	entity=item.title	
	            }
	            count++;	
	        }
	        if (count==1)
        	{
        		ShowEntity(entity);
        	}
        	if (count>1)
        	{
        		Accueil();
        	}
        	HideSearchLoading();
	        
			
    	}
   });
}


function StartMapRefresh()
{
	setInterval("GetEtabsStatus()",60*1000);	
}

var features=null;
function GetEtabsStatus()
{
	bNeedToDraw=(features==null || $("#map_canvas").length!=0 )
	$("#marker_accueil").css("background-image","url('assets/picto/239.gif')");
	$.ajax({
		url:'/main/entities',
	    format: "json",
	    type: 'GET',
	    success: function (data)
	    {	
	    	features=data.features;
	    	for (var i = 0; i < features.length; i++) 
	    	{
	    		item = features[i];
	    		SetEntityMarker(item.title,item.icon)
	    		EnableEntityMarker(item.title,item.icon!="")
	    	}
	    	if (bNeedToDraw) DrawMap();
	    	
	    	$("#marker_accueil").css("background-image","url('assets/picto/map.png')");
	    }
	})
}

var oMapMarker=new Hashtable();
function DrawMap(bForceReload)
{
	bGps=appConfig.get("setgps");
	
	
	
	if (features==null || bForceReload) 
	{
		features=null;
		UIBlock("#map_canvas","Actualisation en cours...");
		GetEtabsStatus();
		return;	
	}
	re = null;
	searchEtab = $("#searchEtab").val();
	if (searchEtab != undefined && searchEtab != "")
		re = new RegExp(".*" + searchEtab + ".*", "i");


	deleteOverlays();
	/*oMapMarker.each(function(key,value)
	{
		value.updated=false;
	});*/

	count = 0;
	for (var i = 0; i < features.length; i++) 
	{
		item = features[i];

		// Critere de recherche
		if (re != null) {
			if (!  re.test(item.title) && ! re.test(item.description)) {
				continue
			}
		}
		count++;

		switch(item.geometry.type) {
			case "Point":

				var marker=null;//=oMapMarker.get(item.title);
				if (marker==null)
				{
					html = "<strong>" + item.title + "</strong><p>" + item.description + "</p>";
					lat = parseFloat(item.geometry.coordinates[1])
					lon = parseFloat(item.geometry.coordinates[0])
					var myLatlng = new google.maps.LatLng(lat, lon);
					var marker = new google.maps.Marker({
						position : myLatlng,
						draggable : bGps,
						title : "[" + item.title + "] " + item.description,
						icon : item.icon,
						updated: true,
						uid : item.title,
					});
					addMarker(marker);
					oMapMarker.put(item.title,marker);
				} /*else
				{
					if (item.icon!=marker.icon) marker.setIcon(item.icon);
					if (marker.getMap()==null) 	marker.setMap(map);
					marker.updated=true;
				}*/
				
				SetEntityMarker(item.title, item.icon)

				
				break;
		}// End switch
	}// End for

	/*oMapMarker.each(function(key,value)
	{
		if (!value.updated)
		{
			value.setMap(null);
		}
		EnableEntityMarker(key,value.updated)
	});*/

	if ( typeof mapsCallback != 'undefined') {
		mapsCallback();
		delete mapsCallback;
	}
	

	// Si un seul établissement, on lance le OnClick
	if (count == 1) {
		onClickMarker(marker);
	}
	
	UIUnBlock("#map_canvas");

	// Si aucun établissement
	if (count == 0) {
		UIBlock("#map_canvas", "Aucun établissement trouvé<br>Veuillez modifier<br> les <b>filtres</b> et/ou le <b>critère de recherche</b>");
		$("#marker_contexte").hide();
		$("#objets").show();
		ajusterLaLongueurDeLaCarte(false);
		return;
	}
	
	recenterMap();
	
	
	

	$('#search-etab').blurjs({
		source : '#header',
		radius : 10,
		overlay : 'rgba(255,255,255,0.5)',
		offset : {
			x : -1,
			y : -1
		}
	});
	w=$(window).width()
    $("#main-navigation").css("width",w*2);
	
	

}


function HideSearchCancel()
{
	$("#cancelSearch").parent().hide();	
}

function ShowSearchLoading()
{
	HideSearchCancel()
	$("#loadingSearch").parent().show();
}

function HideSearchLoading()
{
	$("#cancelSearch").parent().show();
	$("#loadingSearch").parent().hide();
}

function onDblClickMarker(marker)
{
   ShowEntity( marker.uid)
}

function onDragMarker(marker)
{
    $.ajax({
              url: '/entity/'+marker.uid+'/gps'  ,
              data: {lat:marker.position.Xa, lon:marker.position.Ya},
              type: 'POST',success: function( response ){}
     })
}


function onClickMarker(marker)
{
	displayContextuelle(marker.uid,currentPerspectiveContextuelId);	 
}


function shareObjet(rowid,callback)
{
    $.ajax({
    	url: '/main/objet_share',
        //url: '<%= url_for  :controller=> "main",:action => "objet_share"  %>'  ,
        data: {id: rowid},type: 'GET',success: function(data)
        {

        }
    });
}

function filters_delete()
{
    var s;
    s = $("#listfiltres").jqGrid('getGridParam','selarrrow');
    $.ajax({
    	url:'/main/filters_delete',
        //url: '<%= url_for  :controller=> "main",:action => "filters_delete" %>'  ,
        data: {to_delete: s, type: "filtres"},
        type: 'DELETE',success: function( response ) {}
    });
}

function deleteFilter(id)
{
    $.ajax({
    	url:'/main/filters_delete',
       // url: '<%= url_for  :controller=> "main",:action => "filters_delete" %>'  ,
        data: {to_delete: [id]},
        type: 'DELETE',success: function( response ) {}
    });
}


function  editObjet(rowid)
{
    $.ajax({
    	url:'/main/filter_edit',
       // url: '<%= url_for  :controller=> "main",:action => "filter_edit"  %>'  ,
        data: {id: rowid},type: 'GET',success: function(data)
        {
           // eval(data)
        }
    });
}

function checkboxfiltresFormatter(el, cval, opts)
{
    var bchk = el ? "filtres_actif" : "filtres_inactif";
    return  "<div select='"+el+"'id='select_"+cval.rowId+"' class='pointer "+bchk+"' onclick='toggleFilter("+cval.rowId+",this,\"filtres\")'/>";
}

function checkboxperspectivesFormatter(el, cval, opts)
{
    return "";
}

function checkboxUnFormatter(cellvalue, options, cell)
{
    return $('div', cell).attr('select');
}

function editPerspectiveFormatter(el, cval, opts)
{
    ret=""
    if (opts[3]) // IsWritable
    {
        ret ="<button style='width:20px; margin-right: 5px;' class='btn-filter-delete toolbtn editmode_tool' onclick='deleteFilter("+cval.rowId+")'>Supprimer</button>";
        ret=ret + "<button style='width:20px;' class='btn-filter-edit toolbtn' onclick='editObjet("+cval.rowId+")'>Editer</button>";
    }


    return ret
}

function editFormatter(el, cval, opts)
{
    ret=""
    if (opts[3]) // IsWritable
    {
        ret ="<button style='width:20px; margin-right: 5px;' class='btn-filter-delete toolbtn editmode_tool' onclick='deleteFilter("+cval.rowId+")'>Supprimer</button>";
        ret=ret + "<button style='width:20px;' class='btn-filter-edit toolbtn editmode_tool' onclick='editObjet("+cval.rowId+")'>Editer</button>";
    }


    return ret
}

function deleteFormatter(el, cval, opts)
{
    return  "<button class='btn-filter btn-filter-delete toolbtn editmode_tool' onclick='deleteFilter("+cval.rowId+")'>Supprimer</button>";

}

function checkboxvuesFormatter(el, cval, opts)
{
    var bchk = el ? "vues_actif" : "vues_inactif";
    r=opts[4]
    if (r==undefined) {
        r=$("#listvues").jqGrid('getRowData',cval.rowId);
        r= r.picto
    }

    if (opts[5])  // actif?
        return  "<div select='"+el+"'id='select_"+cval.rowId+"' class='picto pointer "+bchk+"' onclick='toggleFilter("+cval.rowId+",this,\"vues\")'>"+
            "<img src='"+appConfig.get("markerpath")+ r+"'>"+
            "</div>";
    else
        return  "<div select='"+el+"'id='select_"+cval.rowId+"' class='picto pointer "+bchk+"'>"+
                "<img src='"+appConfig.get("markerpath")+ r+"'>"+
                "</div>";
}

function deleteVue(id)
{
    $.ajax({
    	url:'/main/vue_delete',
        //url: '<%= url_for  :controller=> "main",:action => "vue_delete" %>'  ,
        data: {to_delete: id},
        type: 'DELETE',success: function( response ) {}
    });


}

function addFilterToVue(id)
{
    $.ajax({
    	url:'/main/vue_add_filter',
        //url: '<%= url_for  :controller=> "main",:action => "vue_add_filter" %>'  ,
        data: {id: id},
        type: 'POST',success: function( response ) {}
    });

}

function nomfiltresFormatter(el, cval, opts)
{
    return  "<div onclick='toggleFilter("+cval.rowId+",this,\"filtres\")'>"+el+"</div>";
}

function nomvuesFormatter(el, cval, opts)
{
    if (cval.rowId.startsWith("separator"))
    {
        return "";
    }
    classe=''
   // if (opts[5])  // actif?
        return  "<div class='actif' onclick='toggleFilter("+cval.rowId+",this,\"vues\")'   >"+el+"</div>";
   // else
   //     return  "<div class='inactif'  >"+el+"</div>";
}


/* =============== Gestion des scripts  =======================*/

function nomscriptsFormatter(el, cval, opts)
{
    return  "<div onclick='showScript("+cval.rowId+",this)'>"+el+"</div>";
}

function showScript(rowid,o)
{
	UIBlock("#main","Chargement en cours...");
	$.ajax({
    	type: 'GET',
        url: '/administration/'+rowid+'/edit',
        data: 'no',
        success: function(data)
        {
        	$("#descriptions").html(data);
        	UIUnBlock("#main")
        }
   });	
}

function checkboxscriptsFormatter(el, cval, opts)
{
    return "";
}
/* =============================================================*/

/* =============== Gestion des perspectives  =======================*/
function nomperspectivesFormatter(el, cval, opts)
{
    return  "<div onclick='showPersective("+cval.rowId+",this)'>"+el+"</div>";
}

var currentPerspective=null;
function showPersective(rowid,o)
{
	$("ul.navigation li").removeClass("active");
	$("#liperspective").addClass("active")

    	UIBlock("#main","Récupération en cours...");
        $.ajax({
        	url:'/entity/'+appConfig.get("entity")+'/perspective',
            //url: '<%= url_for :id=>@entity, :action=> "show" , :controller => "perspective" %>'  ,
            data: {pid: rowid },type: 'GET',success: function(data)
            {
            	 currentPerspective=rowid;
                 $("#main").html(data);
                 UIUnBlock("#perspective");
            }
        });
}
/* =============================================================*/


function  toggleVue(rowid)
{
    $.ajax({
    	url:'/main/vue_toggle',
       // url: '<%= url_for  :controller=> "main",:action => "vue_toggle"  , :method => :post %>'  ,
        data: {id:rowid},
        type: 'POST',success: function( response ){

			if (response.actif)
           	{
            	$("#groupeheader_"+rowid).parent().parent().css({"background-color":"rgba(230,230,255,0.8)"});
            	$("#btn_vue_active_"+rowid).removeClass("inactif")
            	$("#btn_vue_active_"+rowid).addClass("actif")
            } else
            {
            	$("#groupeheader_"+rowid).parent().parent().css({"background-color":"#BBB"});
				$("#btn_vue_active_"+rowid).addClass("inactif")
				$("#btn_vue_active_"+rowid).removeClass("actif")
            }

            response.filtres.forEach(function (v,i)
            {
            	if (response.actif)
            	{
            		$("#"+v+ " td:eq(1) div").addClass("actif")
            		$("#"+v+ " td:eq(1) div").removeClass("inactif")	
            		$("#"+v+ " td:eq(1)").css({"opacity":1,"background-color":"transparent"});	
            	}else
            	{
            		$("#"+v+ " td:eq(1) div").addClass("inactif")
            		$("#"+v+ " td:eq(1) div").removeClass("actif")
            		$("#"+v+ " td:eq(1)").css({"opacity":0.3,"background-color":"#CCC"});
            	}
            });
           
           
            $(".inactif").parent().parent().css({"background-color":"#CCC"});
        	$(".inactif").parent().parent().find("img").css({"opacity":0.3});
        	$(".actif").parent().parent().css({"background-color":"rgba(230,230,255,0.6)"});
        	$(".actif").parent().parent().find("img").css({"opacity":1});
           
           
            DrawMap(true);
        }
    });

}

function  toggleFilter(rowid,o,type)
{
    var b=$("#list"+type).jqGrid('getRowData',rowid);
    b= (b.select == "true");
    b= ! b

    $("#list"+type).jqGrid('setRowData',rowid,{select: b});
    
    if (type=="filtres")
    {
    	$('#filters_filtre-button span.ui-selectmenu-status').text("");
    }

    $.ajax({
        url: '/main/filter_activate'  ,
        data: {id: rowid,actif: b,type: type},type: 'GET',success: function(data)
        {
           // eval(data)
        }
    });
}

