/* tools.onglet 
 * Gestion des onglets
 * 
 * Affichage 
 *   - Accueil
 *   - Rapports
 *   - Gestion
 */


function Accueil()
{
      	unActiveLiEntity();
      	activeLi("accueil");
      	UIBlock("#main","Chargement en cours...")
      	
      	$.ajax({
              url: '/main'  ,
              data: {id:appConfig.get("entity")},
              type: 'GET',success: function( response )
              {
              	$("#main").setContent(response)
              	UIUnBlock("#main");
              	initButton();
              }
        })
          
        $.ajax({
              url: '/main/sidebar'  ,
              data: {id:appConfig.get("entity")},
              type: 'GET',success: function( response )
              {
              	$("#sideheader").setContent(response)
              	initButton();
              	ajusterLaLongueurDeLaCarte(false); 
              }
    	})  
    	
    	$("#siderubriques").html("");
       
}

function Rapports()
{
	unActiveLiEntity();
    activeLi("rapports");
    UIBlock("#main","Chargement en cours...")
    $.ajax({
              url: '/rapports'  ,
              data: {},
              type: 'GET',success: function( response )
              {
              	$("#main").setContent(response)
              	initButton();
              }
        })	
	
}

function Gestion()
{
	unActiveLiEntity();
    activeLi("gérer");
    $.ajax({
              url: '/gestion'  ,
              data: {},
              type: 'GET',success: function( response )
              {
              	$("#main").setContent("<div style='padding:10px;margin:10px;font-size:12px'><br><br>Veuillez sélectionner une rubrique à gérer dans la liste de droite</div>")
              	$("#sideheader").setContent(response)
              	initButton();
              }
        })	
	
}

// Suppression de tous les onglets qui dépassent
// la largeur de la fenêtre
function removeLastOnglets()
{
	w=$(window).width()	
	t=$("#main-navigation").offset().top
	$(".onglet").each(function(i)
	{
		if ($(this).offset().left+$(this).width()>w)
		{
				$(this).remove();
		}
	});
	
	$("li.etabs").each(function(i)
	{
		if ($(this).offset().left+$(this).width()>w || $(this).offset().top>t)
		{
				$(this).remove();
		}
	});
}
