# -*- coding: utf-8 -*-
class ValueObserver < ActiveRecord::Observer

  observe :value

  def after_save(value)
    #value.logger.info("#{value.uid} => #{value.valeur}")
    #puts("#{value.uid} => #{value.valeur}")
    bChanged=value.valeur_changed?
    if value.composante.UPTIME? && value.message.empty?
      bChanged=false  
    end
    
    if bChanged || value.composante.logall?
      attrs=Value.accessible_attributes
      vh=ValueHistory.new(value.attributes.delete_if { |k,v| !attrs.include? k })
      vh.composante=value.composante
      vh.source=value.source
      vh.save
    end
    
    if value.message_changed? && value.message != "" && value.message != nil
      #value.logger.info("[ValueObserver] #{value.valeur_change}")

      attrs=Value.accessible_attributes
      log=Log.new(value.attributes.delete_if { |k,v| !attrs.include? k })
      status=value.getStatut()
      #log.message=status[:message]
      #log.message<< "  <previous>(Valeur précédente:#{value.valeur_change[1]})</previous>" if value.valeur_change != nil
      log.composante=value.composante
      log.source=value.source
      log.save
    end
    
    
    
  end


end
